package com.ff.apimngr.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ff.apimngr.entity.App;
import com.ff.apimngr.service.AppService;
import com.ff.apimngr.util.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;

import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.entity.mime.content.StringBody;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.HttpParams;
import org.apache.http.util.EntityUtils;
import org.springframework.core.env.Environment;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import sun.misc.BASE64Encoder;

import javax.annotation.Resource;
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.Charset;
import java.security.SignatureException;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.List;
import java.util.concurrent.atomic.AtomicLong;

@Api(hidden = true)
@RestController
@RequestMapping("/api/demo")
public class DemoController {


    //商汤接口使用
    private static final String id = "86c33d88f44d493eabc24bb47f1afd6d";
    //商汤接口使用
    private static final String secret = "3a3c7b6b57b24e57aade2986a5dd226f";






    @Resource
    AppService appService;

    @Resource
    private Environment env;

    public static String accessToken = "";

    @ApiOperation(value = "人脸对比", notes = "人脸对比")
    @PostMapping(value = "/compare")
    public Map<String, Object> faceCompare(@ApiParam(value = "图片", required = true) @RequestParam String image1,
                                           @ApiParam(value = "图片类型", required = true) @RequestParam String imageType1,
                                           @ApiParam(value = "人脸的类型", required = true) @RequestParam String faceType1,
                                           @ApiParam(value = "活体控制", required = true) @RequestParam String livenessControl1,
                                           @ApiParam(value = "图片类型", required = true) @RequestParam String image2,
                                           @ApiParam(value = "图片类型", required = true) @RequestParam String imageType2,
                                           @ApiParam(value = "人脸的类型", required = true) @RequestParam String faceType2,
                                           @ApiParam(value = "活体控制", required = true) @RequestParam String livenessControl2) {
        Map<String, Object> result = new HashMap<>();
        String profile = env.getActiveProfiles()[0];
        String base64Image1 = "";
        if ("BASE64".equals(imageType1))
        {
            if (image1.startsWith("http")) {
                base64Image1 = Base64Encode.getImageStrbyUrl(image1);
            }
            else
            {
                if ("dev".equals(profile.toString())) {
                    base64Image1 = Base64Encode.getImageStr("D:/test/compare/" + image1 + ".png");
                } else {
                    base64Image1 = Base64Encode.getImageStr("/home/apimngr/compare/" + image1 + ".png");
                }

            }

        }
        String base64Image2 = "";
        if ("BASE64".equals(imageType2))
        {
            if (image2.startsWith("http"))
            {
                base64Image2 = Base64Encode.getImageStrbyUrl(image2);
            }
            else
             {
                if ("dev".equals(profile.toString()))
                {
                    base64Image2 = Base64Encode.getImageStr("D:/test/compare/" + image2 + ".png");
                }
                else
                {
                    base64Image2 = Base64Encode.getImageStr("/home/apimngr/compare/" + image2 + ".png");
                }

            }
        }
        if (base64Image2.length() == 0 || base64Image1.length() == 0)
        {
            result.put("code", 10002);
            result.put("message", "图片转Base64出错");
            return result;
        }
        List<Object> params = new ArrayList<>();
        Map<String, Object> param1 = new HashMap<>();
        param1.put("image", base64Image1);
        param1.put("image_type", imageType1);
        param1.put("face_type", faceType1);
        param1.put("quality_control", "LOW");
        param1.put("liveness_control", livenessControl1);
        params.add(param1);
        Map<String, Object> param2 = new HashMap<>();
        param2.put("image", base64Image2);
        param2.put("image_type", imageType2);
        param2.put("face_type", faceType2);
        param2.put("quality_control", "LOW");
        param2.put("liveness_control", livenessControl2);
        params.add(param2);
        JSONArray array = JSONArray.parseArray(JSON.toJSONString(params));
        String url = String.format("%s/face-api/v3/face/match",Config.BASE_HOST);
        Map<String, String> headers = new HashMap<>();
        headers.put("access_token", accessToken);

        System.err.println("access_token:"+accessToken);

        String PostString = HttpUtils.doPostByJson(url, headers, array);
        System.err.println("PostString:"+PostString);
        JSONObject object = JSONObject.parseObject(PostString);
        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null == errorMsg) {
            errorMsg = object.getString("err_msg");
        }
        if (0 == errorCode && "SUCCESS".equals(errorMsg))
        {
            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);
            JSONObject data = object.getJSONObject("result");
            Map<String, Object> map = new HashMap<>();
            map.put("score", String.valueOf(data.getFloat("score")));
            JSONArray jsonArray = data.getJSONArray("face_list");
            List<Object> tokens = new ArrayList<>();
            for (int i = 0; i < jsonArray.size(); i++)
            {
                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                Map<String, String> mm = new HashMap<>();
                mm.put("face_token", jsonObject.getString("face_token"));
                tokens.add(mm);
            }
            map.put("face_list", tokens);
            result.put("data", map);
        } else {
            result.put("code", 10001);
            result.put("message", errorMsg);
        }

        return result;
    }


    @ApiOperation(value = "人脸检测", notes = "人脸检测")
    @PostMapping(value = "/detect")
    public Map<String, Object> faceDetect(@ApiParam(value = "图片", required = true) @RequestParam String image,
                                          @ApiParam(value = "图片类型", required = true) @RequestParam String imageType,
                                          @ApiParam(value = "人脸的类型", required = true) @RequestParam String faceField,
                                          @ApiParam(value = "关键点", required = true) @RequestParam String landMark) throws IOException {
        Map<String, Object> result = new HashMap<>();
        System.out.println(image);
        String base64Image = "";
        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        if (StringUtils.isEmpty(accessToken))
        {
             getAccessToken();
        }
//        String imgParam= "";
        if ("BASE64".equals(imageType))
        {
            if (image.startsWith("http"))
            {
                               ;
                base64Image = Base64Encode.getImageStrbyUrl(image);
                //base64Image = Base64Encode.getImageStrbyUrlBase64(image);
                srcPath = image;
                if ("dev".equals(profile.toString())) {
                    filePath = "D:/test/detect_result/" + System.currentTimeMillis() + ".jpg";
                } else {
                    filePath = "/home/apimngr/detect_result/" + System.currentTimeMillis() + ".jpg";
                }
            }
            else
            {
                if ("dev".equals(profile.toString()))
                {
                    srcPath = "D:/test/detect/" + image + ".jpg";
                    filePath = "D:/test/detect_result/" + image + ".jpg";
                    //
//                    byte[] imgData = FileUtil.readFileByBytes(srcPath);
//                    String imgStr = Base64Util.encode(imgData);
//                    base64Image = URLEncoder.encode(imgStr, "UTF-8");
                    base64Image = Base64Encode.getImageStr("D:/test/detect/" + image + ".jpg");
                }
                else
                {
                    srcPath = "/home/apimngr/detect/" + image + ".jpg";
                    filePath = "/home/apimngr/detect_result/" + image + ".jpg";

//                    byte[] imgData = FileUtil.readFileByBytes(srcPath);
//                    String imgStr = Base64Util.encode(imgData);
//                    base64Image = URLEncoder.encode(imgStr, "UTF-8");

                    base64Image = Base64Encode.getImageStr("/home/apimngr/detect/" + image + ".jpg");
                }
            }
        }
        if (base64Image.length() == 0) {
            result.put("code", 10001);
            result.put("message", "图片Base64转码出错");
            return result;
        }
        Map<String, Object> param = new HashMap<>();
        param.put("image", base64Image);
        param.put("image_type", imageType);
        faceField = faceField + ",landmark";// + landMark;
        param.put("face_field", faceField);
        param.put("max_face_num", 10);
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(param));
        //正式AI服务器
        String url =String.format("%s/face-api/v3/face/detect",Config.BASE_HOST);
        Map<String, String> headers = new HashMap<>();
        headers.put("access_token", accessToken);
        String PostString = HttpUtils.doPostByJson(url, headers, jsonObject);

        System.err.println(PostString);
        JSONObject object = JSONObject.parseObject(PostString);
        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null == errorMsg) {
            errorMsg = object.getString("err_msg");
        }
        if (null != errorCode && null != errorMsg && 0 == errorCode && "SUCCESS".equals(errorMsg))
        {
            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);
            JSONObject data = object.getJSONObject("result");
            Map<String, Object> map = new HashMap<>();
            map.put("faceNum", data.getInteger("face_num"));
            JSONArray jsonArray = data.getJSONArray("face_list");
            List<Object> faceList = new ArrayList<>();
            List<Object> list = new ArrayList<>();

            for (int i = 0; i < jsonArray.size(); i++)
            {
                JSONObject json = (JSONObject) jsonArray.get(i);

                JSONArray array = json.getJSONArray("landmark72");
                String outPath;
                if ("dev".equals(profile.toString())) {
                    outPath = "D:/test/detect_result/" + System.currentTimeMillis() + ".jpg";
                } else {
                    outPath = "/home/apimngr/detect_result/" + System.currentTimeMillis() + ".jpg";
                }
                try {
                    drawDot(srcPath, outPath, array,"");
                } catch (Exception e) {
                    e.printStackTrace();
                    result.put("code", 10004);
                    result.put("message", "图片处理失败");
                    return result;
                }


                int x = (int) json.getJSONObject("location").getDoubleValue("left");
                int y = (int) json.getJSONObject("location").getDoubleValue("top");
                int width = (int) json.getJSONObject("location").getDoubleValue("width");
                int height = (int) json.getJSONObject("location").getDoubleValue("height");
                //json.getJSONObject("location").getDoubleValue("rotation");
                try {
                    filePath = drawRectOnImage(srcPath, filePath, x, y, width, height);
                    srcPath = filePath;
                } catch (Exception e) {
                    e.printStackTrace();
                    result.put("code", 10003);
                    result.put("message", "图片处理失败");
                    return result;
                }
                Map<String, Object> m = new HashMap<>();
                m.put("path", outPath);
                m.put("face_token", json.getString("face_token"));
                m.put("face_probability", json.getDoubleValue("face_probability")*100 + "%");//人脸置信度
                m.put("age", json.getInteger("age"));
                String gender = json.getJSONObject("gender").getString("type");
                if ("female".equals(gender)) {
                    m.put("gender", "女性");
                } else if ("male".equals(gender)) {
                    m.put("gender", "男性");
                } else {
                    m.put("gender", "未知");
                }
                m.put("gender_probability",json.getJSONObject("gender").getDoubleValue("probability")*100 + "%");
                String race = json.getJSONObject("race").getString("type");
                if ("yellow".equals(race)) {
                    m.put("race", "黄种人");
                } else if ("white".equals(race)) {
                    m.put("race", "白种人");
                } else if ("black".equals(race)) {
                    m.put("race", "黑种人");
                } else if ("arabs".equals(race)) {
                    m.put("race", "阿拉伯人");
                } else {
                    m.put("race", "");
                }
                m.put("race_probability",json.getJSONObject("race").getDoubleValue("probability")*100 + "%");
                m.put("beauty", json.getDouble("beauty").intValue());
                //string none:不笑；smile:微笑；laugh:大笑
                String expression = json.getJSONObject("expression").getString("type");
                if ("none".equals(expression)) {
                    m.put("expression", "不笑");
                } else if ("smile".equals(expression)) {
                    m.put("expression", "微笑");
                } else if ("laugh".equals(expression)) {
                    m.put("expression", "大笑");
                } else {
                    m.put("expression", "");
                }
                m.put("expression_probability",json.getJSONObject("expression").getDoubleValue("probability")*100 + "%");
                //none:无眼镜，common:普通眼镜，sun:墨镜
                String glasses = json.getJSONObject("glasses").getString("type");
                if ("none".equals(glasses)) {
                    m.put("glasses", "无眼镜");
                } else if ("common".equals(glasses)) {
                    m.put("glasses", "普通眼镜");
                } else if ("sun".equals(glasses)) {
                    m.put("glasses", "墨镜");
                } else {
                    m.put("glasses", "");
                }
                m.put("glasses_probability",json.getJSONObject("glasses").getDoubleValue("probability")*100 + "%");
                String emotion = json.getJSONObject("emotion").getString("type");
                if ("angry".equals(emotion)) {
                    m.put("emotion", "愤怒");
                } else if ("disgust".equals(emotion)) {
                    m.put("emotion", "厌恶");
                } else if ("fear".equals(emotion)) {
                    m.put("emotion", "恐惧");
                } else if ("happy".equals(emotion)) {
                    m.put("emotion", "高兴");
                } else if ("sad".equals(emotion)) {
                    m.put("emotion", "伤心");
                } else if ("surprise".equals(emotion)) {
                    m.put("emotion", "惊讶");
                } else if ("neutral".equals(emotion)) {
                    m.put("emotion", "无情绪");
                } else {
                    m.put("emotion", "");
                }
                m.put("emotion_probability",json.getJSONObject("emotion").getDoubleValue("probability")*100 + "%");
                m.put("rotation", json.getJSONObject("location").getInteger("rotation"));
                m.put("angle", json.getJSONObject("angle"));
                m.put("quality", json.getJSONObject("quality"));
                faceList.add(m);
                list.add(json);
            }
            map.put("filePath", filePath);
            map.put("faceListPath", faceList);
            map.put("faceList", list);
            result.put("data", map);
        } else {
            result.put("code", 10001);
            result.put("message", errorMsg);
        }
        return result;
    }

    //@ApiOperation(value = "初始化人脸库", notes = "初始化人脸库")


    @ApiOperation(value = "人脸添加", notes = "人脸添加")
    @PostMapping(value = "/addface")
    public Map<String, Object> addFace(@ApiParam(value = "图片", required = true) @RequestParam String image)
    {
        Map<String, Object> result = new HashMap<>();
        String  newImg = image.substring(image.indexOf("=")+1);
        String base64Image = Base64Encode.getImageStr(newImg);//BASE64
        if (base64Image.length() == 0) {
            System.out.println("图片转Base64出错");
            result.put("code", 10001);
            result.put("message", "图片转Base64出错");
            return result;
        }
        Map<String, Object> param = new HashMap<>();
        param.put("image", base64Image);
        param.put("image_type", "BASE64");
        int ran = (int) (Math.random() * (9999 - 1000 + 1)) + 1000;
        param.put("user_id", "demouser" + ran);
        param.put("group_id", "demogroup2019");
        param.put("user_info", image);
        param.put("quality_control", "LOW");
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(param));

        String url = String.format("%s/face-api/v3/face/add",Config.BASE_HOST);
        Map<String, String> headers = new HashMap<>();
        headers.put("access_token", accessToken);
        String PostString = HttpUtils.doPostByJson(url, headers, jsonObject);
//        String PostString = null;
//        try {
//            PostString = HttpUtils.post(url, GetToken.getAuth(), "application/json",GsonUtils.toJson(param));
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
        JSONObject object = JSONObject.parseObject(PostString);
        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null == errorMsg) {
            errorMsg = object.getString("err_msg");
        }
        if (0 == errorCode && "SUCCESS".equals(errorMsg)) {
            //请求成功
            JSONObject data = object.getJSONObject("result");
            System.out.println(data.getString("face_token"));
            JSONObject json = data.getJSONObject("location");
            System.out.println(json);
        } else {
            System.out.println("注册人脸库失败");
        }
        result.put("code", 10000);
        result.put("message", "人脸库添加成功");
        return result;

    }

    public static void main(String[] args) {
//        deleteFaceLib();

        initFaceLib();
        //getFaceLib();
    }

    public static void initFaceLib() {
        String base64Image = "";
        for (int i = 0; i < 5; i++) {
            //if ("dev".equals(profile.toString())) {
            base64Image = Base64Encode.getImageStr("D:/test/search/" + (i + 1) + ".jpg");
            //} else {
            //    base64Image = Base64Encode.getImageStr("/home/apimngr/search/" + i + ".jpg");
            //}
            if (base64Image.length() == 0) {
                System.out.println("图片转Base64出错");
            }
            Map<String, Object> param = new HashMap<>();
            param.put("image", base64Image);
            param.put("image_type", "BASE64");
            param.put("user_id", "demouser2019");
            param.put("group_id", "demogroup2019");
            param.put("user_info", "http://182.254.204.70:7788/api/file/getimg?fileUrl=/home/apimngr/search/" + (i + 1) + ".jpg");
            param.put("quality_control", "LOW");
            JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(param));
            String url = String.format("%s/face-api/v3/face/add",Config.BASE_HOST);
            Map<String, String> headers = new HashMap<>();
            headers.put("access_token", "a43ec480948b8eecef0517b6fb2d3dff");
            String PostString = HttpUtils.doPostByJson(url, headers, jsonObject);
            JSONObject object = JSONObject.parseObject(PostString);
            Integer errorCode = object.getInteger("error_code");
            String errorMsg = object.getString("error_msg");
            if (null == errorMsg) {
                errorMsg = object.getString("err_msg");
            }
            if (0 == errorCode && "SUCCESS".equals(errorMsg)) {
                //请求成功
                JSONObject data = object.getJSONObject("result");
                System.out.println(data.getString("face_token"));
                JSONObject json = data.getJSONObject("location");
                System.out.println(json);
            } else {
                System.out.println("注册人脸库失败");
            }
        }
    }

    public static void deleteFaceLib() {

        Map<String, Object> param = new HashMap<>();
        param.put("user_id", "demouser2019");
        param.put("group_id", "demogroup2019");
        param.put("face_token", "9d5328633a0d4f48c241d2125c3d3ad4");
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(param));
        String url = String.format("%s/face-api/v3/face/delete",Config.BASE_HOST);
        Map<String, String> headers = new HashMap<>();
        headers.put("access_token", "08fc47408020f57538f090553a417299");
        String PostString = HttpUtils.doPostByJson(url, headers, jsonObject);
        JSONObject object = JSONObject.parseObject(PostString);
        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null == errorMsg) {
            errorMsg = object.getString("err_msg");
        }
        if (0 == errorCode && "SUCCESS".equals(errorMsg)) {
            //请求成功
            JSONObject data = object.getJSONObject("result");
            System.out.println(data);
        } else {
            System.out.println("删除人脸库失败:" + errorMsg);
        }
    }

    public static void getFaceLib() {

        Map<String, Object> param = new HashMap<>();
        param.put("user_id", "demouser2019");
        param.put("group_id", "demogroup2019");
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(param));

        String url =String.format("%s/face-api/v3/face/list",Config.BASE_HOST);
        Map<String, String> headers = new HashMap<>();
        headers.put("access_token", "08fc47408020f57538f090553a417299");
        String PostString = null;
        try {
            PostString = HttpUtils.post(url, GetToken.getAuth(), "application/json",GsonUtils.toJson(param));
        } catch (Exception e) {
            e.printStackTrace();
        }
        JSONObject object = JSONObject.parseObject(PostString);
        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null == errorMsg) {
            errorMsg = object.getString("err_msg");
        }
        if (0 == errorCode && "SUCCESS".equals(errorMsg)) {
            //请求成功
            JSONObject data = object.getJSONObject("result");
            System.out.println(data);
        } else {
            System.out.println("获取人脸库列表失败");
        }
    }

    @ApiOperation(value = "人脸搜索", notes = "人脸搜索")
    @PostMapping(value = "/search")
    public Map<String, Object> faceSearch(@ApiParam(value = "图片", required = true) @RequestParam String image,
                                          @ApiParam(value = "图片类型", required = true) @RequestParam String imageType,
                                          @ApiParam(value = "人脸库用户id", required = false) @RequestParam(required = false) String userId) throws IOException {
        Map<String, Object> result = new HashMap<>();
        String base64Image = "";
        String profile = env.getActiveProfiles()[0];
        if ("BASE64".equals(imageType)) {
            if (image.startsWith("http")) {
                base64Image = Base64Encode.getImageStrbyUrl(image);
            } else {
                if ("dev".equals(profile.toString())) {
                    base64Image = Base64Encode.getImageStr("D:/test/search/" + image + ".jpg");
                } else {
                    base64Image = Base64Encode.getImageStr("/home/apimngr/search/" + image + ".jpg");
                }

            }
        }
        if (base64Image.length() == 0) {
            result.put("code", 10001);
            result.put("message", "图片Base64转码出错");
            return result;
        }
        Map<String, Object> param = new HashMap<>();
        param.put("image", base64Image);
        param.put("image_type", imageType);
        param.put("group_id_list", "demogroup2019");
        //param.put("quality_control", "LOW");
        param.put("max_user_num", 4);
        /*if (null != userId && userId.length() > 0) {
            param.put("user_id", userId);
        }*/
        SimpleDateFormat format = new SimpleDateFormat("yyyy-mm-dd HH:MM:ss SSS");
        result.put("startTime",format.format(new Date()));
        String params = GsonUtils.toJson(param);
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(param));
        String url = String.format("%s/face-api/v3/face/identify",Config.BASE_HOST);
        Map<String, String> headers = new HashMap<>();
        headers.put("access_token", accessToken);
        String PostString = null;
        try {
            PostString = HttpUtils.doPostByJson(url,  headers, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("Post Reult : " + PostString);
        JSONObject object = JSONObject.parseObject(PostString);
        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null == errorMsg) {
            errorMsg = object.getString("err_msg");
        }
        result.put("endTime",format.format(new Date()));
        if (null != errorCode && 0 == errorCode && null != errorMsg && "SUCCESS".equals(errorMsg)) {
            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);
            JSONObject data = object.getJSONObject("result");
            result.put("data", data);
        } else {
            result.put("code", 10001);
            result.put("message", errorMsg);
        }
        return result;
    }


    /**
     * 人体关键点识别
     * @param image
     * @return
     */
    @ApiOperation(value = "人体关键点识别", notes = "人体关键点识别")
    @PostMapping(value = "/bodyAnalysis")
    public Map<String, Object> bodyAnalysis(@ApiParam(value = "图片", required = true) @RequestParam String image) throws IOException {

        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
//        String imgParam="";
        //初始化返回数据容器
        // 请求url
        Map<String,Object> result = new HashMap<String,Object>();
        //处理图片
        if (image.startsWith("http"))
        {
            base64Image = Base64Encode.getImageStrbyUrl(image);
            srcPath = image;
            if ("dev".equals(profile.toString())) {
                filePath = "D:/test/bodyAnalysis_result/" + System.currentTimeMillis() + ".jpg";
            } else {
                filePath = "/home/apimngr/bodyAnalysis_result/" + System.currentTimeMillis() + ".jpg";
            }
        }
        else {
            if ("dev".equals(profile.toString())) {
                srcPath = "D:/test/bodyAnalysis/" + image + ".jpg";
                filePath = "D:/test/bodyAnalysis_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("D:/test/bodyAnalysis/" + image + ".jpg");
            } else {
                srcPath = "/home/apimngr/bodyAnalysis/" + image + ".jpg";
                filePath = "/home/apimngr/bodyAnalysis_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("/home/apimngr/bodyAnalysis/" + image + ".jpg");
            }
        }
        Map<String, Object> param = new HashMap<>();
        base64Image = URLEncoder.encode(base64Image);
        param.put("image",base64Image);
        Map<String,String> headMap = new HashMap<>();
        headMap.put("access_token",accessToken);
        String url =String.format("%s/rest/2.0/image-classify/v1/body_analysis",Config.BASE_HOST) ;
        String PostString = null;
        try {
            PostString = HttpUtils.doPostByForm(url,headMap , param);
        } catch (Exception e) {
            e.printStackTrace();
         }
        System.out.println("Post Reult : " + PostString);
        JSONObject object = JSONObject.parseObject(PostString);

        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        object = object.getJSONObject("result");
        if (0 == errorCode) {
            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);

            JSONArray jsonArray = object.getJSONArray("person_info");
            //取出来要绘制的点
            JSONArray array = new JSONArray();
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject json = (JSONObject) jsonArray.get(i);

                for (Map.Entry<String, Object> entry : json.entrySet()) {
                    if (!entry.getKey().equals("location")) {
                        JSONObject object1 = (JSONObject) entry.getValue();
                        for (Map.Entry<String, Object> entry1 : object1.entrySet()) {
                            array.add(entry1.getValue());
                        }
                    }
                }
//                int x = (int) json.getJSONObject("location").getDoubleValue("left");
//                int y = (int) json.getJSONObject("location").getDoubleValue("top");
//                int width = (int) json.getJSONObject("location").getDoubleValue("width");
//                int height = (int) json.getJSONObject("location").getDoubleValue("height");
//                //json.getJSONObject("location").getDoubleValue("rotation");
//                try {
//                    filePath = drawRectOnImage(srcPath, filePath, x, y, width, height);
//                    srcPath = filePath;
//                } catch (Exception e) {
//                    e.printStackTrace();
//                    result.put("code", 10003);
//                    result.put("message", "图片处理失败");
//                    return result;
//                }
                System.out.println(json);
            }
            String outPath;
            if ("dev".equals(profile.toString())) {
                outPath = "D:/test/bodyAnalysis_result/" + System.currentTimeMillis() + ".jpg";
            } else {
                outPath = "/home/apimngr/bodyAnalysis_result/" + System.currentTimeMillis() + ".jpg";
            }
            try {
                System.out.println(srcPath);
                drawDot(srcPath, outPath, array,"src");
                System.out.println(outPath);
            } catch (Exception e) {
                e.printStackTrace();
                result.put("code", 10004);
                result.put("message", "图片处理失败");
                return result;
            }
            //解析数据
            object.put("filePath",outPath);
            result.put("data",object);
        }
        return result;
    }

    /**
     * 人体检测和属性识别
     * @param image
     * @param type
     * @return
     * @throws IOException
     */
    @ApiOperation(value = "人体检测和属性识别", notes = "人体检测和属性识别")
    @PostMapping(value = "/bodyAttr")
    public Map<String, Object> bodyAttr(@ApiParam(value = "图片", required = true) @RequestParam String image,
                                         @ApiParam(value = "可选属性",required = false) @RequestParam(value = "type",required = false) String type) {

        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
//        String imgParam="";
        //初始化返回数据容器
        // 请求url
        Map<String,Object> result = new HashMap<String,Object>();
        //处理图片
        if (image.startsWith("http")) {
            base64Image = Base64Encode.getImageStrbyUrl(image);
            srcPath = image;
            if ("dev".equals(profile.toString())) {
                filePath = "D:/test/bodyAttr_result/" + System.currentTimeMillis() + ".jpg";
            } else {
                filePath = "/home/apimngr/bodyAttr_result/" + System.currentTimeMillis() + ".jpg";
            }
        } else {
            if ("dev".equals(profile.toString())) {
                srcPath = "D:/test/bodyAttr/" + image + ".jpg";
                filePath = "D:/test/bodyAttr_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("D:/test/bodyAttr/" + image + ".jpg");
            } else {
                srcPath = "/home/apimngr/bodyAttr/" + image + ".jpg";
                filePath = "/home/apimngr/bodyAttr_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("/home/apimngr/bodyAttr/" + image + ".jpg");
            }
        }
        if (base64Image.length() == 0) {
            System.out.println("图片转Base64出错");
            result.put("code", 10001);
            result.put("message", "图片转Base64出错");
            return result;
        }
        //参数
        Map<String, Object> param = new HashMap<>();
        base64Image = URLEncoder.encode(base64Image);
        param.put("image",base64Image);
        if (!StringUtils.isEmpty(type)){
            param.put("type",type);
        }
        Map<String,String> headMap = new HashMap<>();
        headMap.put("access_token",accessToken);
        String url = String.format("%s/rest/2.0/image-classify/v1/body_attr",Config.BASE_HOST) ;
        String PostString = null;
        try {
            PostString = HttpUtils.doPostByForm(url,headMap , param);
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("Post Reult : " + PostString);
        JSONObject object = JSONObject.parseObject(PostString);

        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if ( 0 == errorCode ) {

            List<Object> personList = new ArrayList<>();//装自定义数据
            DecimalFormat df = new DecimalFormat(".0000");

            List<Object> person_info = new ArrayList<>();//装json
            Map<String,Object> dataMap = new HashMap<String, Object>();
            object = object.getJSONObject("result");
            dataMap.put("person_num",object.getInteger("person_num"));

            JSONArray jsonArray = object.getJSONArray("person_info");
            //取出位置信息  进行边框描绘
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject json = (JSONObject) jsonArray.get(i);
                //检测信息
                Map<String,Object> resultMap = new HashMap<String,Object>();
                resultMap.put("path",filePath);
                JSONObject jb = json.getJSONObject("attributes");
                for (Map.Entry<String, Object> entry : jb.entrySet()) {
                    if (!entry.getKey().equals("location")) {
                        JSONObject object1 = (JSONObject) entry.getValue();
                        resultMap.put(entry.getKey().toString(),object1.get("name"));
                        resultMap.put(entry.getKey().toString()+"_probability",df.format(object1.getDoubleValue("score")*100)+"%");
                    }
                }
                //位置信息
                int x = (int) json.getJSONObject("location").getDoubleValue("left");
                int y = (int) json.getJSONObject("location").getDoubleValue("top");
                int width = (int) json.getJSONObject("location").getDoubleValue("width");
                int height = (int) json.getJSONObject("location").getDoubleValue("height");
                //json.getJSONObject("location").getDoubleValue("rotation");
                try {
                    filePath = drawRectOnImage(srcPath, filePath, x, y, width, height);
                    srcPath = filePath;
                } catch (Exception e) {
                    e.printStackTrace();
                    result.put("code", 10003);
                    result.put("message", "图片处理失败");
                    return result;
                }

                resultMap.put("path",srcPath);
                personList.add(resultMap);
                person_info.add(json);
            }
            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);

            //解析数据
            dataMap.put("filePath",filePath);
            dataMap.put("person_info",person_info);
            dataMap.put("resultPersonInfo",personList);
            result.put("data",dataMap);
        }
        return result;
    }


    /**
     * 人流量统计
     * @param image
     * @param area
     * @param show
     * @return
     * @throws IOException
     */
    @ApiOperation(value = "人流量统计", notes = "人流量统计")
    @PostMapping(value = "/bodyNum")
    public Map<String, Object> bodyNum(@ApiParam(value = "图片", required = true) @RequestParam String image,
                                        @ApiParam(value = "选择区域",required = false)
                                        @RequestParam(value = "area",required = false) String area,
                                        @ApiParam(value = "图片返显",required = false)
                                        @RequestParam(value = "show",required = false) String show) throws IOException
    {

        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
        String imgParam="";
        //初始化返回数据容器
        // 请求url
        Map<String,Object> result = new HashMap<String,Object>();
        //处理图片
        if (image.startsWith("http")) {
            base64Image = Base64Encode.getImageStrbyUrl(image);
            srcPath = image;
            if ("dev".equals(profile.toString())) {
                filePath = "D:/test/bodyNum_result/" + System.currentTimeMillis() + ".jpg";
            } else {
                filePath = "/home/apimngr/bodyNum_result/" + System.currentTimeMillis() + ".jpg";
            }
        } else {
            if ("dev".equals(profile.toString())) {
                srcPath = "D:/test/bodyNum/" + image + ".jpg";
                filePath = "D:/test/bodyNum_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("D:/test/bodyNum/" + image + ".jpg");
            } else {
                srcPath = "/home/apimngr/bodyNum/" + image + ".jpg";
                filePath = "/home/apimngr/bodyNum_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("/home/apimngr/bodyNum/" + image + ".jpg");
            }
        }
        if (base64Image.length() == 0) {
            System.out.println("图片转Base64出错");
            result.put("code", 10001);
            result.put("message", "图片转Base64出错");
            return result;
        }
        //参数
//        drawRectOnImage("D:\\test\\bodyNum\\1.jpg","D:\\test\\bodyNum\\67.jpg",490,750,200,200);
        Map<String, Object> param = new HashMap<>();
        base64Image = URLEncoder.encode(base64Image);
        param.put("image",base64Image);
        if ("1".equals(show)){
            show = "2";
        }
        param.put("show",show);
//        param.put("area","90,820,290,820,290,1020,90,1020");
//        param.put("area","90,820,290,820,290,1020,90,1020;490,1020,690,1020,690,820,490,820");
        Map<String,String> headMap = new HashMap<>();
        headMap.put("access_token",accessToken);
        headMap.put("Content-Type","application/x-www-form-urlencoded");
        String url = String.format("%s/rest/2.0/image-classify/v1/body_num",Config.BASE_HOST) ;
        String PostString = null;
        try
        {
            PostString = HttpUtils.doPostByForm(url,headMap , param);
        }
        catch (Exception e)
        {
            System.err.println(e.getLocalizedMessage());
            //e.printStackTrace();
        }
        System.out.println("Post Reult : " + PostString);
        JSONObject object = JSONObject.parseObject(PostString);

        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (0 == errorCode ) {
            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);
            object = object.getJSONObject("result");
            //解析图片编码
            if (object.containsKey("image"))
            {
//                if (!Base64Util.generateImage(object.getString("image"),filePath)){
//                    result.put("message", "图片解码出错");
//                }else {
                    object.put("filePath",filePath);
//                }
            }else{
                object.put("filePath",srcPath);
            }
            Map<String,Object> dataMap = new HashMap<String, Object>();
            //解析数据
//            object.put("filePath",filePath);
            result.put("data",object);
        }
        return result;
    }

    /**
     * 手势识别
     * @param image
     * @return
     * @throws IOException
     */
    @ApiOperation(value = "手势识别", notes = "手势识别")
    @PostMapping(value = "/gesture")
    public Map<String, Object> gesture(@ApiParam(value = "图片", required = true) @RequestParam String image) throws IOException {

        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
        Map<String,String> gestureMap = GetGesture.queryAll();//手势数据集合

        //初始化返回数据容器
        Map<String,Object> result = new HashMap<String,Object>();
        //处理图片
        if (image.startsWith("http"))
        {
            base64Image = Base64Encode.getImageStrbyUrl(image);
            srcPath = image;
            if ("dev".equals(profile.toString())) {
                filePath = "D:/test/gesture_result/" + System.currentTimeMillis() + ".jpg";
            } else {
                filePath = "/home/apimngr/gesture_result/" + System.currentTimeMillis() + ".jpg";
            }
        } else {
            if ("dev".equals(profile.toString())) {
                srcPath = "D:/test/gesture/" + image + ".jpg";
                filePath = "D:/test/gesture_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("D:/test/gesture/" + image + ".jpg");
            } else {
                srcPath = "/home/apimngr/gesture/" + image + ".jpg";
                filePath = "/home/apimngr/gesture_result/" + image + ".jpg";
                base64Image = Base64Encode.getImageStr("/home/apimngr/gesture/" + image + ".jpg");
            }
        }
        if (base64Image.length() == 0) {
            System.out.println("图片转Base64出错");
            result.put("code", 10001);
            result.put("message", "图片转Base64出错");
            return result;
        }
        //参数
        Map<String, Object> param = new HashMap<>();
        base64Image = URLEncoder.encode(base64Image);
        param.put("image",base64Image);
        Map<String,String> headMap = new HashMap<>();
        headMap.put("access_token",accessToken);
        headMap.put("Content-Type","application/x-www-form-urlencoded");
        String url =String.format("%s/rest/2.0/image-classify/v1/gesture",Config.BASE_HOST) ;
        String PostString = null;
        try {
            PostString = HttpUtils.doPostByForm(url,headMap , param);
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("Post Reult : " + PostString);
        JSONObject object = JSONObject.parseObject(PostString);

        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (0 == errorCode ) {

            List<Object> jsonList = new ArrayList<>();//json数据容器
            List<Object> gestureList = new ArrayList<>();//装自定义数据
            DecimalFormat df = new DecimalFormat(".0000");//定义小数位

            Map<String,Object> dataMap = new HashMap<String, Object>();


            JSONArray ja = object.getJSONObject("result").getJSONArray("object");
            int j = ja.size();
            for (int i =0;i<j;i++){

                Map<Object,Object> map = new HashMap<>();
                //绘制图片
                JSONObject json = ja.getJSONObject(i);

                if (!gestureMap.containsKey(json.getString("classname"))){
                    map.put("name",gestureMap.get(json.getString("Other")));
                }else {
                    map.put("name",gestureMap.get(json.getString("classname")));
                }
                map.put("classname",json.getString("classname"));
                map.put("probability",df.format(json.getDoubleValue("probability")*100)+"%");


                int x = (int) json.getDoubleValue("left");
                int y = (int) json.getDoubleValue("top");
                int width = (int) json.getDoubleValue("width");
                int height = (int) json.getDoubleValue("height");
                //json.getJSONObject("location").getDoubleValue("rotation");
                try {
                    filePath = drawRectOnImage(srcPath, filePath, x, y, width, height);
                    srcPath = filePath;
                } catch (Exception e) {
                    e.printStackTrace();
                    result.put("code", 10003);
                    result.put("message", "图片处理失败");
                    return result;
                }
                map.put("path",filePath);
                gestureList.add(map);
                jsonList.add(json);
            }

            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);
            dataMap.put("result",jsonList);
            dataMap.put("resultInfo",gestureList);
            //解析数据
            dataMap.put("filePath",filePath);
            dataMap.put("result_num",object.getIntValue("result_num"));
            dataMap.put("log_id",object.get("log_id"));
            result.put("data",dataMap);
        }
        return result;
    }


    /**
     * 在线活体检测
     * @param image
     * @return
     * @throws IOException
     */
    @ApiOperation(value = "在线活体检测", notes = "在线活体检测")
    @PostMapping(value = "/faceVerify")
    public Map<String, Object> faceVerify(@ApiParam(value = "图片", required = true) @RequestParam String image,
                                          @ApiParam(value = "图片格式",required = true) @RequestParam String imageType,
                                          @ApiParam(value = "需要返回的参数",required = false) @RequestParam String faceField) throws IOException {

        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
        Map<String,String> gestureMap = GetGesture.queryAll();//手势数据集合

        //初始化返回数据容器
        Map<String,Object> result = new HashMap<String,Object>();
        //处理图片
        if (image.startsWith("http"))
        {
            base64Image = Base64Encode.getImageStrbyUrl(image);
            srcPath = image;
            if ("dev".equals(profile.toString()))
            {
                filePath = "D:/test/faceVerify_result/" + System.currentTimeMillis() + ".jpg";
            }
            else
            {
                filePath = "/home/apimngr/faceVerify_result/" + System.currentTimeMillis() + ".jpg";
            }
        }
        else
        {
            if ("dev".equals(profile.toString()))
            {
                srcPath = "D:/test/faceVerify/" + image + ".jpg";
                filePath = "D:/test/faceVerify_result/" + image + ".jpg";
                byte[] imgData = FileUtil.readFileByBytes(srcPath);
                 base64Image = Base64Util.encode(imgData);
            }
            else
            {
                srcPath = "/home/apimngr/faceVerify/" + image + ".jpg";
                filePath = "/home/apimngr/faceVerify_result/" + image + ".jpg";
                byte[] imgData = FileUtil.readFileByBytes(srcPath);
                 base64Image = Base64Util.encode(imgData);
            }
        }
        if (base64Image.length() == 0) {
            System.out.println("图片转Base64出错");
            result.put("code", 10001);
            result.put("message", "图片转Base64出错");
            return result;
        }
        //请求参数
        Map<String, Object> paramMap = new HashMap<String,Object>();
        paramMap.put("image", base64Image);
        paramMap.put("image_type", imageType);
        paramMap.put("face_field",faceField);

        JSONObject jo = new JSONObject(paramMap);
        List<String>  param = new ArrayList<String>();
        param.add(jo.toJSONString());

        String url = String.format("%s/face-api/v3/face/liveness",Config.BASE_HOST);

        String PostString = null;
        try
        {
            PostString = HttpUtils.post(url,accessToken ,"application/json", param.toString());
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        System.out.println("Post Reult : " + PostString);
        JSONObject object = JSONObject.parseObject(PostString);

        Integer errorCode = object.getInteger("error_code");
        String errorMsg = object.getString("error_msg");
        if (null != errorMsg) {
            errorMsg = object.getString("error_msg");
        }
        if (0 == errorCode && "SUCCESS" .equals( errorMsg ) ) {

            List<Object> jsonList = new ArrayList<>();//json数据容器
            List<Object> fvList = new ArrayList<>();//装自定义数据
            DecimalFormat df = new DecimalFormat("");//定义小数位
            JSONObject json = object.getJSONObject("result");
            jsonList.add(json);

            Map<String,Object> dataMap = new HashMap<String, Object>();
            //解析由服务端返回最新的阈值数据（随着模型的优化，阈值可能会变化），将此参数与返回的face_liveness进行比较，可以作为活体判断的依据。
            JSONObject thresholdsJson = json.getJSONObject("thresholds");//阀值
            dataMap.put("frr_1e-2",thresholdsJson.getDoubleValue("frr_1e-2"));//百分之一误识率的阈值
            dataMap.put("frr_1e-3",thresholdsJson.getDoubleValue("frr_1e-3"));//千分之一误识率的阈值
            dataMap.put("frr_1e-4",thresholdsJson.getDoubleValue("frr_1e-4"));//万分之一误识率的阈值；
            dataMap.put("face_liveness",json.getDoubleValue("face_liveness"));//活体分数值
            String  face_liveness = df.format(json.getDoubleValue("face_liveness") * 100) + "%";
            dataMap.put("face_token",json.getDoubleValue("face_token"));//活体分数值
            JSONArray ja = json.getJSONArray("face_list");
            for (int i = 0; i<ja.size();i++){
                JSONObject jsonObject = ja.getJSONObject(i);
                Map<String,Object> m = new HashMap<String,Object>();
                m.put("face_token",jsonObject.getString("face_token"));
                m.put("face_liveness",face_liveness);
                if (jsonObject.containsKey("age")){
                    m.put("age",jsonObject.getIntValue("age"));
                }
                if (jsonObject.containsKey("beauty")) {
                    m.put("beauty", jsonObject.getDoubleValue("beauty"));
                }
                if (jsonObject.containsKey("face_probability")) {
                    m.put("face_probability", df.format(jsonObject.getDoubleValue("face_probability") * 100) + "%");//人脸置信度
                }
                if (jsonObject.containsKey("angle")) {
                    m.put("angle_yaw", jsonObject.getJSONObject("angle").getDoubleValue("yaw"));
                    m.put("angle_pitch", jsonObject.getJSONObject("angle").getDoubleValue("pitch"));
                    m.put("angle_roll", jsonObject.getJSONObject("angle").getDoubleValue("roll"));
                }
                if (jsonObject.containsKey("gender")) {
                    String gender = jsonObject.getJSONObject("gender").getString("type");
                    if ("female".equals(gender)) {
                        m.put("gender", "女性");
                    } else if ("male".equals(gender)) {
                        m.put("gender", "男性");
                    } else {
                        m.put("gender", "未知");
                    }
                    m.put("gender_probability", df.format(jsonObject.getJSONObject("gender").getDoubleValue("probability") * 100) + "%");
                }
                if (jsonObject.containsKey("race")) {
                    String race = jsonObject.getJSONObject("race").getString("type");
                    if ("yellow".equals(race)) {
                        m.put("race", "黄种人");
                    } else if ("white".equals(race)) {
                        m.put("race", "白种人");
                    } else if ("black".equals(race)) {
                        m.put("race", "黑种人");
                    } else if ("arabs".equals(race)) {
                        m.put("race", "阿拉伯人");
                    } else {
                        m.put("race", "");
                    }
                    m.put("race_probability", df.format(jsonObject.getJSONObject("race").getDoubleValue("probability") * 100) + "%");
                }
                //string none:不笑；smile:微笑；laugh:大笑
                if (jsonObject.containsKey("expression")) {
                    String expression = jsonObject.getJSONObject("expression").getString("type");
                    if ("none".equals(expression)) {
                        m.put("expression", "不笑");
                    } else if ("smile".equals(expression)) {
                        m.put("expression", "微笑");
                    } else if ("laugh".equals(expression)) {
                        m.put("expression", "大笑");
                    } else {
                        m.put("expression", "");
                    }
                    m.put("expression_probability", df.format(jsonObject.getJSONObject("expression").getDoubleValue("probability") * 100) + "%");
                }
                //none:无眼镜，common:普通眼镜，sun:墨镜
                if (jsonObject.containsKey("glasses")) {
                    String glasses = jsonObject.getJSONObject("glasses").getString("type");
                    if ("none".equals(glasses)) {
                        m.put("glasses", "无眼镜");
                    } else if ("common".equals(glasses)) {
                        m.put("glasses", "普通眼镜");
                    } else if ("sun".equals(glasses)) {
                        m.put("glasses", "墨镜");
                    } else {
                        m.put("glasses", "");
                    }
                    m.put("glasses_probability", df.format(jsonObject.getJSONObject("glasses").getDoubleValue("probability") * 100) + "%");
                }
                //脸型类型
                if (jsonObject.containsKey("face_type")) {
                    String face_type = jsonObject.getJSONObject("face_type").getString("type");
                    if (("human").equals(face_type)) {
                        m.put("face_type", "真实人脸");
                    } else if ("cartoon".equals(face_type)) {
                        m.put("face_type", "卡通人脸");
                    } else {
                        m.put("face_type", "未知");
                    }
                    m.put("face_type_probability", df.format(jsonObject.getJSONObject("face_type").getDoubleValue("probability") * 100) + "%");
                }
                //脸型 square: 正方形 triangle:三角形 oval: 椭圆 heart: 心形 round: 圆形
                if (jsonObject.containsKey("face_shape")) {
                    String face_shape = jsonObject.getJSONObject("face_shape").getString("type");
                    if ("square".equals(face_shape)) {
                        m.put("face_shape", "正方形");
                    } else if ("triangle".equals(face_shape)) {
                        m.put("face_shape", "三角形");
                    } else if ("oval".equals(face_shape)) {
                        m.put("face_shape", "椭圆");
                    } else if ("heart".equals(face_shape)) {
                        m.put("face_shape", "心形");
                    } else if ("round".equals(face_shape)) {
                        m.put("face_shape", "圆形");
                    } else {
                        m.put("face_shape", "");
                    }
                    m.put("face_shape_probability", df.format(jsonObject.getJSONObject("face_shape").getDoubleValue("probability") * 100) + "%");
                    if (jsonObject.containsKey("emotion")) {
                        String emotion = jsonObject.getJSONObject("emotion").getString("type");
                        if ("angry".equals(emotion)) {
                            m.put("emotion", "愤怒");
                        } else if ("disgust".equals(emotion)) {
                            m.put("emotion", "厌恶");
                        } else if ("fear".equals(emotion)) {
                            m.put("emotion", "恐惧");
                        } else if ("happy".equals(emotion)) {
                            m.put("emotion", "高兴");
                        } else if ("sad".equals(emotion)) {
                            m.put("emotion", "伤心");
                        } else if ("surprise".equals(emotion)) {
                            m.put("emotion", "惊讶");
                        } else if ("neutral".equals(emotion)) {
                            m.put("emotion", "无情绪");
                        } else {
                            m.put("emotion", "");
                        }
                        m.put("emotion_probability", df.format(jsonObject.getJSONObject("emotion").getDoubleValue("probability") * 100) + "%");
                    }
                }
                //取出人脸位置  进行标记
                int x = (int) jsonObject.getJSONObject("location").getDoubleValue("left");
                int y = (int) jsonObject.getJSONObject("location").getDoubleValue("top");
                int width = (int) jsonObject.getJSONObject("location").getDoubleValue("width");
                int height = (int) jsonObject.getJSONObject("location").getDoubleValue("height");
                try {
                    filePath = drawRectOnImage(srcPath, filePath, x, y, width, height);
                    srcPath = filePath;
                } catch (Exception e) {
                    e.printStackTrace();
                    result.put("code", 10003);
                    result.put("message", "图片处理失败");
                    return result;
                }
                m.put("path",filePath);
                fvList.add(m);
            }

            //请求成功
            result.put("code", 10000);
            result.put("message", errorMsg);
            dataMap.put("result",jsonList);
            dataMap.put("resultInfo",fvList);
            //解析数据
            dataMap.put("filePath",filePath);
            dataMap.put("log_id",object.get("log_id"));
            result.put("data",dataMap);
        }
        return result;
    }


    /**
     * 获取语音校验码及session_id
     * @return
     */
    @ApiOperation(value = "获取语音校验码", notes = "获取语音校验码")
    @PostMapping(value = "/getSessionCode")
    public Map<String,Object> getSessionCode()
    {

        Map<String,Object> result = new HashMap<String,Object>();
        try {

            String param = GetToken.getAuth();
            String requestUrl = "https://aip.baidubce.com/rest/2.0/face/v1/faceliveness/sessioncode?access_token="+param;

            String resultString = HttpUtils.post(requestUrl, param, "");
            JSONObject jo = JSONObject.parseObject(resultString);
            if (jo.getInteger("error_code")!=0){
                result.put("code",jo.getIntValue("error_code"));
                result.put("message",jo.getString("error_msg"));
                result.put("voice_code","");//语音校验码
                result.put("serverlogid",jo.getString("serverlogid"));
            }else {
                result.put("code",10000);
                result.put("serverlogid",jo.getString("serverlogid"));
                jo = jo.getJSONObject("result");
                result.put("voice_code",jo.getString("code"));//语音校验码
                result.put("session_id",jo.getString("session_id"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

//        result.put("code",10000);
//        result.put("message","success");
//        result.put("voice_code",(int)(1+Math.random()*(10000-1+1)));
//        result.put("serverlogid","hlahfhashfhvl");
//        result.put("session_id","S5d1eeabb69e59427388647");
        return result;
    }

    /**
     * 在线h5视频活体检测
     * @return
     */
    @ApiOperation(value = "在线h5视频活体检测", notes = "在线h5视频活体检测")
    @PostMapping(value = "/hVideo")
    public Map<String,Object> hVideo(@ApiParam(value = "视频", required = true) @RequestParam(value = "videoBase64",required = true) String videoBase64,
                                     @ApiParam(value = "语音校验码会话id",required = true) @RequestParam(value = "session_id",required = false) String sessionCodeId)
    {

        Map<String,Object> result = new HashMap<String,Object>();
        String param = GetToken.getAuth();
//        String url = String.format("%s/rest/2.0/face/v1/faceliveness/verify",Config.BASE_HOST);
        String url = "https://aip.baidubce.com/rest/2.0/face/v1/faceliveness/verify?access_token="+param;
        try
        {
//            videoBase64 = URLEncoder.encode(videoBase64,"UTF-8");
            String tempBase64 = URLEncoder.encode(videoBase64,"UTF-8");
            if(tempBase64==null || tempBase64.trim().isEmpty())
            {
                tempBase64=videoBase64;
            }

            String params = "video_base64="+tempBase64;
            if (!"".equals(sessionCodeId)&&null!=sessionCodeId){
                params = params+"&session_id="+sessionCodeId;
            }
//            String accessToken =  GetToken.getAuth();
//            System.out.println(accessToken);

            String resultData = HttpUtils.post(url,param,"application/x-www-form-urlencoded",params,"utf-8");
            JSONObject resultJson = JSONObject.parseObject(resultData);
//            System.out.println(resultJson);
            Integer code = resultJson.getInteger("error_code");
            String  errorMsg = resultJson.getString("error_msg");
            //错误信息解析
            Map<String,Object> verifyData = new HashMap<>();
            result.put("serverlogid",resultJson.getString("serverlogid"));
            result.put("timestamp",resultJson.getLongValue("timestamp"));
            //调用失败
            if (0!=code)
            {
                result.put("code",code);
                result.put("message",errorMsg);
            }
            else
            {
                result.put("code",10000);
                result.put("message",errorMsg);
                resultJson = resultJson.getJSONObject("result");
                Map<String,Object>  m = new HashMap<String, Object>();
                m.put("thresholds_frr_1e_4",resultJson.getJSONObject("thresholds").getDoubleValue("frr_1e-4"));
                m.put("thresholds_frr_1e_3",resultJson.getJSONObject("thresholds").getDoubleValue("frr_1e-3"));
                m.put("thresholds_frr_1e_2",resultJson.getJSONObject("thresholds").getDoubleValue("frr_1e-2"));
                m.put("score",resultJson.getFloatValue("score"));
                m.put("picList",resultJson.getJSONArray("pic_list"));
                if(resultJson.getJSONObject("code")!=null)
                {
                    m.put("identify",resultJson.getJSONObject("code").getString("identify"));
                    m.put("create",resultJson.getJSONObject("code").getString("create"));
                }

                result.put("data",m);
            }
//            System.out.println(result);
           try
           {
               String  aiUri = String.format("%s/face-api/face/liveness",Config.BASE_HOST);
               JSONObject jsonObject = new JSONObject();
               jsonObject.put("video_base64",videoBase64);
               String resultData2 = HttpUtils.post(aiUri,accessToken,"application/json",jsonObject.toJSONString(),"utf-8");
//               System.err.println(resultData2);
           }
           catch (Exception ee)
           {
               ee.printStackTrace();
           }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }


        return result;
    }

    //商汤接口 idCard 与  idBankCard

    @ApiOperation(value = "商汤银行卡识别", notes = "商汤银行卡识别")
    @PostMapping(value = "/senseTimeBankCard")
    public Map<String,Object> senseTimeBankCard(@ApiParam(value = "图片", required = true) @RequestParam(value = "image_file",required = false) String image){
        Map<String,Object> result = new HashMap<>();
        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
        try {
            if (image.startsWith("http")) {

              srcPath = image;
                if ("dev".equals(profile.toString())) {
                    filePath = "D:/test/bankCard_result/" + System.currentTimeMillis() + ".jpg";
                } else {
                    filePath = "/home/apimngr/bankCard_result/" + System.currentTimeMillis() + ".jpg";
                }

                String base64Data = Base64Encode.getImageStrbyUrl(srcPath);
                if (Base64Encode.Base64ToImage(base64Data,filePath)){
                    srcPath = filePath;
                }else {
                    result.put("code", 10003);
                    result.put("message", "图片处理失败");
                    return result;
                }

            } else {
                if ("dev".equals(profile.toString())) {
                    srcPath = "D:/test/bankCard/" + image + ".jpg";
                    filePath = "D:/test/bankCard_result/" + image + ".jpg";
                } else {
                    srcPath = "/home/apimngr/bankCard/" + image + ".jpg";
                    filePath = "/home/apimngr/bankCard_result/" + image + ".jpg";
                }
            }

        String POST_URL="https://v2-auth-api.visioncloudapi.com/ocr/bankcard/stateless";
        HttpClient httpclient = new DefaultHttpClient();
        HttpPost post = new HttpPost(POST_URL);
        FileBody fileBody = new FileBody(new File(srcPath));
        MultipartEntity entity = new MultipartEntity();
        entity.addPart("image_file", fileBody);
        post.setEntity(entity);
        post.setHeader("Authorization", SenseTimeAuthString.genHeaderParam(id,secret));//请将AUTHORIZATION替换为根据API_KEY和API_SECRET得到的签名认证串
        HttpResponse response = httpclient.execute(post);
        if (response.getStatusLine().getStatusCode() == 200) {
            HttpEntity entitys = response.getEntity();
            BufferedReader reader = new BufferedReader(
                    new InputStreamReader(entitys.getContent()));
            String line = reader.readLine();
            JSONObject resultJson = JSONObject.parseObject(line);
            result.put("code",resultJson.getIntValue("code"));
            result.put("request_id",resultJson.getString("request_id"));
            result.put("path",srcPath);
            if (resultJson.getIntValue("code")==1000){
                result.put("code",10000);
                result.put("data",resultJson.get("info"));
                List<Object> list = new ArrayList<>();
                Map<String,Object> m = new HashMap<>();
                JSONObject jo = resultJson.getJSONObject("info");
                if (jo.containsKey("bank_identification_number")){
                    m.put("bank_identification_number",jo.getString("bank_identification_number"));
                }
                if (jo.containsKey("bank_name")){
                    m.put("bank_name",jo.getString("bank_name"));
                }
                if (jo.containsKey("card_name")){
                    m.put("card_name",jo.getString("card_name"));
                }
                if (jo.containsKey("card_number")){
                    m.put("card_number",jo.getString("card_number"));
                }
                if (jo.containsKey("card_type")){
                    m.put("card_type",jo.getString("card_type"));
                }
                m.put("filePath",srcPath);
                list.add(m);
                result.put("faceListPath",list);
            }else {
                result.put("message",resultJson.getString("message"));
            }
        }else{
            HttpEntity r_entity = response.getEntity();
            String responseString = EntityUtils.toString(r_entity);
            result.put("code",response.getStatusLine().getStatusCode()+"  "+response.getStatusLine().getReasonPhrase());
            result.put("message",responseString);
            System.out.println("错误码是："+response.getStatusLine().getStatusCode()+"  "+response.getStatusLine().getReasonPhrase());
            System.out.println("出错原因是："+responseString);
            //你需要根据出错的原因判断错误信息，并修改
        }
        httpclient.getConnectionManager().shutdown();
        } catch (SignatureException e) {
            e.printStackTrace();
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }


        return result;
    }

    /**
     *
     * @param image
     * @return
     */
    @ApiOperation(value = "商汤身份证识别", notes = "商汤身份证识别")
    @PostMapping(value = "/senseTimeIdCard")
    public Map<String,Object> senseTimeIdCard(@ApiParam(value = "图片", required = true) @RequestParam(value = "image_file",required = true) String image,
                                              @ApiParam(value = "是否旋转", required = false) @RequestParam(value = "auto_rotate",required = false) boolean auto_rotate,
                                              @ApiParam(value = "正反面", required = false) @RequestParam(value = "side",required = false) String side,
                                              @ApiParam(value = "身份证来源", required = false) @RequestParam(value = "classify",required = false) boolean classify,
                                              @ApiParam(value = "图片", required = false) @RequestParam(value = "return_score",required = false) boolean return_score){
        Map<String,Object> result = new HashMap<>();
        String srcPath = "";
        String filePath = "";
        String profile = env.getActiveProfiles()[0];
        String base64Image = "";//BASE64
        try {
            if (image.startsWith("http")) {
                srcPath = image;
                if ("dev".equals(profile.toString())) {
                    filePath = "D:/test/idCard_result/" + System.currentTimeMillis() + ".jpg";
                } else {
                    filePath = "/home/apimngr/idCard_result/" + System.currentTimeMillis() + ".jpg";
                }
                String base64Data = Base64Encode.getImageStrbyUrl(srcPath);
                if (Base64Encode.Base64ToImage(base64Data,filePath)){
                    srcPath = filePath;
                }else {
                    result.put("code", 10003);
                    result.put("message", "图片处理失败");
                    return result;
                }
            } else {
                if ("dev".equals(profile.toString())) {
                    srcPath = "D:/test/idCard/" + image + ".jpg";
                    filePath = "D:/test/idCard_result/" + image + ".jpg";
                } else {
                    srcPath = "/home/apimngr/idCard/" + image + ".jpg";
                    filePath = "/home/apimngr/idCard_result/" + image + ".jpg";
                }
            }

            String POST_URL="https://v2-auth-api.visioncloudapi.com/ocr/idcard/stateless";
            HttpClient httpclient = new DefaultHttpClient();
            HttpPost post = new HttpPost(POST_URL);
            FileBody fileBody = new FileBody(new File(srcPath));
            MultipartEntity entity = new MultipartEntity();
            entity.addPart("image_file", fileBody);
            entity.addPart("auto_rotate",new StringBody(String.valueOf(auto_rotate), Charset.forName("UTF-8")));
            entity.addPart("side",new StringBody(String.valueOf(side), Charset.forName("UTF-8")));
            entity.addPart("classify",new StringBody(String.valueOf(classify), Charset.forName("UTF-8")));
            entity.addPart("return_score",new StringBody(String.valueOf(return_score), Charset.forName("UTF-8")));
            post.setEntity(entity);
            post.setHeader("Authorization", SenseTimeAuthString.genHeaderParam(id,secret));//请将AUTHORIZATION替换为根据API_KEY和API_SECRET得到的签名认证串
            HttpResponse response = httpclient.execute(post);
            if (response.getStatusLine().getStatusCode() == 200) {
                HttpEntity entitys = response.getEntity();
                BufferedReader reader = new BufferedReader(
                        new InputStreamReader(entitys.getContent()));
                String line = reader.readLine();
                JSONObject resultJson = JSONObject.parseObject(line);
                System.out.println(resultJson);
                result.put("code",resultJson.getIntValue("code"));
                result.put("request_id",resultJson.getString("request_id"));
                result.put("path",srcPath);
                Map<String,Object> map = new HashMap<>();
                if (resultJson.getIntValue("code")==1000){
                    result.put("code",10000);
                    List<Object> list  = new ArrayList<>();
                    Map<String,Object> m = new HashMap<>();
                    if (resultJson.containsKey("info")){
                        map.put("info",resultJson.get("info"));
                        JSONObject jo = resultJson.getJSONObject("info");
                        m.put("address",jo.getString("address"));
                        m.put("gender",jo.getString("gender"));
                        m.put("nation",jo.getString("nation"));
                        m.put("number",jo.getString("number"));
                        m.put("name",jo.getString("name"));
                        m.put("birthday",jo.getString("year")+"年"+jo.getString("month")+"月"+jo.getString("day")+"日");
                    }
                    if (resultJson.containsKey("validity")){
                        map.put("validity",resultJson.get("validity"));
                        JSONObject jo = resultJson.getJSONObject("validity");
//                        if (jo.containsKey("name")&&jo.containsKey("address")&&jo.containsKey("gener")&&jo.containsKey("number")&&jo.containsKey("birthday")){
                        m.put("v_name",jo.getBoolean("name"));
                        m.put("v_address",jo.getBoolean("address"));
                        m.put("v_gender",jo.getBoolean("gender"));
                        m.put("v_number",jo.getBoolean("number"));
                        m.put("v_birthday",jo.getBoolean("birthday"));
//                        }
                    }
                    if (resultJson.containsKey("score")){
                        map.put("score",resultJson.get("score"));
                        JSONObject jo = resultJson.getJSONObject("score");
//                        if (jo.containsKey("name")&&jo.containsKey("gender")&&
//                            jo.containsKey("address")&&jo.containsKey("nation")&&
//                            jo.containsKey("number")&&jo.containsKey("year")){
                        DecimalFormat df = new DecimalFormat("0");
                        m.put("socre_name",df.format(jo.getFloatValue("name")*100)+"%");
                        m.put("socre_gender",df.format(jo.getFloatValue("gender")*100)+"%");
                        m.put("socre_address",df.format(jo.getFloatValue("address")*100)+"%");
                        m.put("socre_nation",df.format(jo.getFloatValue("nation")*100)+"%");
                        m.put("socre_number",df.format(jo.getFloatValue("number")*100)+"%");
                        m.put("socre_year",df.format(jo.getFloatValue("year")*100)+"%");
//                        }

                    }
                    if (resultJson.containsKey("type")){
                        String type = resultJson.getString("type");
                        map.put("type",resultJson.getString("type"));
                        if (type.equals("normal")){
                            m.put("type","正常拍摄");
                        }
                        else if (type.equals("photocopy")){
                            m.put("type","复印件");
                        }
                        else if (type.equals("reversion")){
                            m.put("type","屏幕翻拍");
                        }
                        else if (type.equals("other")){
                            m.put("type","其他");
                        }
                        else if (type.equals("ps")){
                            m.put("type","PS");
                        }
                        else if (type.equals("unknown")){
                            m.put("type","未知");
                        }
                    }
                    m.put("path",srcPath);
                    list.add(m);
                    result.put("data",map);
                    result.put("faceListPath",list);
                }else {
                    result.put("message",resultJson.getString("message"));
                }
            }else{
                HttpEntity r_entity = response.getEntity();
                String responseString = EntityUtils.toString(r_entity);
                result.put("code",response.getStatusLine().getStatusCode()+"  "+response.getStatusLine().getReasonPhrase());
                result.put("message",responseString);
                System.out.println("错误码是："+response.getStatusLine().getStatusCode()+"  "+response.getStatusLine().getReasonPhrase());
                System.out.println("出错原因是："+responseString);
            }
            httpclient.getConnectionManager().shutdown();
        } catch (SignatureException e) {
            e.printStackTrace();
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }


    public String drawRectOnImage(String srcPath, String outPath, int x, int y, int width, int height) throws IOException
    {
        //InputStream in = new FileInputStream(srcPath);//图片路径
        File file = new File(outPath);
        File fileParent = file.getParentFile();
        if(!fileParent.exists()){
            fileParent.mkdirs();
        }
        BufferedImage image = null;
        String fileSuffix = srcPath.substring(srcPath.lastIndexOf(".") + 1);
        if (srcPath.startsWith("http"))
        {
            System.err.println("img-url-old:"+srcPath);
            srcPath = srcPath.replace("https://aicloudapi.wo186.tv","http://172.16.118.149:8081");
            System.err.println("img-url-new:"+srcPath);
            image = ImageIO.read(new URL(srcPath));
        } else {
            image = ImageIO.read(new File(srcPath));
        }
        Graphics g = image.getGraphics();
        Graphics2D g2 = (Graphics2D) g;
        g2.setStroke(new BasicStroke(2.0f));
        g2.setColor(Color.BLUE);//画笔颜色
        g2.drawRect(x, y, width, height);//矩形框(原点x坐标，原点y坐标，矩形的长，矩形的宽)
        FileOutputStream out = new FileOutputStream(outPath);//输出图片的地址
        ImageIO.write(image, fileSuffix, out);
        return outPath;
    }

    public void drawDot(String srcPath, String outPath, JSONArray jsonArray, String imageSource) throws IOException
    {
        //InputStream in = new FileInputStream(srcPath);//图片路径
        try
        {
            BufferedImage image = null;
            File file = new File(outPath);
            File fileParent = file.getParentFile();
            if(!fileParent.exists()){
                fileParent.mkdirs();
            }
            String fileSuffix = srcPath.substring(srcPath.lastIndexOf(".") + 1);
            if (srcPath.startsWith("http"))
            {
                System.err.println("img-url-old:"+srcPath);
                srcPath = srcPath.replace("https://aicloudapi.wo186.tv","http://172.16.118.149:8081");
                System.err.println("img-url-new:"+srcPath);
                image = ImageIO.read(new URL(srcPath));
            } else {
                image = ImageIO.read(new File(srcPath));
            }
            Graphics g = image.getGraphics();
            Graphics2D g2 = (Graphics2D) g;
            g2.setStroke(new BasicStroke(3.0f));
            if (imageSource.equals("src")){
                g2.setColor(Color.RED);
                g2.setStroke(new BasicStroke(12.0f));
            }else {
                g2.setColor(Color.BLUE);//画笔颜色
            }
            int minX = 0, maxX = 0, minY = 0, maxY = 0;
            if (null != jsonArray && jsonArray.size() > 0) {
                for (int i = 0; i < jsonArray.size(); i++) {
                    JSONObject ob = jsonArray.getJSONObject(i);
                    int x = ob.getDouble("x").intValue();
                    int y = ob.getDouble("y").intValue();
                    if (minX == 0) {
                        minX = x;
                    } else if (minX > x) {
                        minX = x;
                    }
                    if (maxX == 0) {
                        maxX = x;
                    } else if (maxX < x) {
                        maxX = x;
                    }
                    if (minY == 0) {
                        minY = y;
                    } else if (minY > y) {
                        minY = y;
                    }
                    if (maxY == 0) {
                        maxY = y;
                    } else if (maxY < y) {
                        maxY = y;
                    }
                    g2.drawLine(x, y, x, y);//画点
                }
            }
            BufferedImage usbImage = null;
            if (imageSource.equals("src")){
                usbImage = image;
            }else {
                usbImage = image.getSubimage(minX, minY, (maxX - minX), (maxY - minY));
            }
            FileOutputStream out = new FileOutputStream(outPath);//输出图片的地址
            ImageIO.write(image, fileSuffix, out);
        }
        catch (Exception e)
        {
            System.err.println("drawDot-error"+e.getLocalizedMessage());
        }


    }


    public void   getAccessToken() {
        //fixme, 使用 “演示应用” appid=11来测试
        App app = appService.findAppById(45);
        Map<String, Object> param = new HashMap<>();
        param.put("grant_type", "client_credentials");
        param.put("client_id", app.getApiKey());
        param.put("client_secret", app.getSecretKey());
        String url =String.format("%s/oauth/2.0/token",Config.BASE_HOST);
        JSONObject json = new JSONObject(param);
        String PostString = HttpUtils.doPostByJson(url, null, json);
        System.out.println(PostString);
        JSONObject object = JSONObject.parseObject(PostString);

        String accessToken = object.getString("access_token");
        System.out.println(accessToken);
        DemoController.accessToken = accessToken;
    }

}
