package com.ff.apimngr.controller;


import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

/**
 * redis缓存接口
 */


@RestController
@RequestMapping("api/redis")
@Api(value = "redis缓存controller", hidden = true,tags = {"redis缓存接口"})
public class RedisController {

    @Autowired
    private StringRedisTemplate stringRedisTemplate;

    @PostMapping("/test")
    @ApiOperation(value = "test", notes = "test",hidden = true)
    public Map<String, Object> testRedis(@ApiParam(required = true, value = "redis健") @RequestParam String key) {
        Map<String, Object> result = new HashMap<>();
        String rst = stringRedisTemplate.opsForValue().get(key);

        result.put("redisKey", key);
        result.put("redisValue", rst);
        return result;
    }
}
