package com.ff.apimngr.dao;

import com.ff.apimngr.entity.ApiType;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


@Mapper
public interface ApiTypeMapper {


    /**
     * 根据id查找
     * @param id
     * @return
     */
    ApiType findById(Integer id);

    /**
     * 根据姓名查找
     * @param name
     * @return
     */
    ApiType findByName(String name);

    /**
     * 插入
     * @param apiType
     * @return
     */
    boolean insert(ApiType apiType);

    /**
     * 更新
     * @param apiType
     * @return
     */
    boolean update(ApiType apiType);

    /**
     * 根据id删除
     * @param id
     * @return
     */
    boolean deleteById(Integer id);

    /**
     * 根据tag搜索列表
     * @param tag
     * @return
     */
    List<ApiType> listApiTypes(@Param("tag") String tag);
}
