/**
 * 
 */
package com.ff.apimngr.dao;

import java.util.List;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;

import com.ff.apimngr.entity.ApiVersion;

/**
 * @author wookvn
 *
 */
@Mapper
public interface ApiVersionMapper {

	@Insert("insert into t_api_version(api_id, old_version, create_by, remark, create_time) values(#{apiId}, #{oldVersion}, #{createBy}, #{remark}, now())")
	@Options(useGeneratedKeys = true, keyProperty = "id", keyColumn = "id")
	public int insert(ApiVersion apiVersion);
	
	
	@Select("select * from t_api_version where api_id = #{value}")
	@Results({ 
		@Result(id = true, column = "id", property = "id"),
        @Result(column = "api_id", property = "apiId"),
        @Result(column = "remark", property = "remark"),
        @Result(column = "create_by", property = "createBy"),
        @Result(column = "create_time", property = "createTime"),
        @Result(column = "old_version", property = "oldVersion")})
	public List<ApiVersion> list(Integer apiId);
}
