package com.ff.apimngr.dao;

import com.ff.apimngr.entity.Role;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


@Mapper
public interface RoleMapper {


    /**
     * 根据id查找
     * @param id
     * @return
     */
    Role findById(Integer id);

    /**
     * 根据姓名查找
     * @param name
     * @return
     */
    Role findByName(String name);

    /**
     * 插入
     * @param role
     * @return
     */
    boolean insert(Role role);

    /**
     * 更新
     * @param role
     * @return
     */
    boolean update(Role role);

    /**
     * 根据id删除
     * @param id
     * @return
     */
    boolean deleteById(Integer id);

    /**
     * 根据tag搜索列表
     * @param tag
     * @return
     */
    List<Role> listRoles(@Param("tag")String tag);

    List<Role> getRoleList();


}
