package com.ff.apimngr.service;

import com.ff.apimngr.dao.ApiLogMapper;
import com.ff.apimngr.entity.*;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class ApiLogService {

    @Resource
    private ApiLogMapper apiLogMapper;

    public ApiLog findApiLogById(Integer id) {
        return apiLogMapper.findById(id);
    }

    public boolean deleteApiLogById(Integer id) {
        return apiLogMapper.deleteById(id);
    }

    public List<ApiLog> listApiLogsByInvokeTime(Long beginDate, Long endDate) {
        return apiLogMapper.listApiLogsByInvokeTime(beginDate, endDate);
    }

    public List<CountResult> selectGeneralCount(Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectGeneralCount(userId, beginDate, endDate);
    }

    public boolean insertApiLog(ApiLog apiLog) {
        return apiLogMapper.insert(apiLog);
    }

    public void insertToDayTable(Long beginDate, Long endDate) {
        apiLogMapper.insertToDayTable(beginDate, endDate);
    }

    public void insertToHourTable(Long beginDate, Long endDate) {
        apiLogMapper.insertToHourTable(beginDate, endDate);
    }

    public List<Item> selectDayReport(Integer appId, Integer apiId, Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectDayReport(appId, apiId, userId, beginDate, endDate);
    }

    public List<Item> selectHourReport(Integer appId, Integer apiId, Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectHourReport(appId, apiId, userId, beginDate, endDate);
    }

    public List<Item> selectMinuteReport(Integer appId, Integer apiId, Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectMinuteReport(appId, apiId, userId, beginDate, endDate);
    }

    public Integer selectQpsReport(Integer appId, Integer apiId, Integer userId, long beginDate, long endDate) {
        return apiLogMapper.selectQpsReport(appId, apiId, userId, beginDate, endDate);
    }

    public List<FailDetail> selectFailDetail(Integer appId, Integer apiId, Integer userId, Long beginDate, Long endDate) {
        return apiLogMapper.selectFailDetail(appId, apiId, userId, beginDate, endDate);
    }

    public List<FailDetail> selectFailDetailDay(Integer appId, Integer apiId, Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectFailDetailDay(appId, apiId, userId, beginDate, endDate);
    }

    public List<ApiReport> selectApiReport(Integer appId, Integer apiId, Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectApiReport(appId, apiId, userId, beginDate, endDate);
    }

    public List<DeveloperReport> selectDeveloperReport(Integer userId, String beginDate, String endDate) {
        return apiLogMapper.selectDeveloperReport(userId, beginDate, endDate);
    }

    public void deleteAll() {
        apiLogMapper.deleteAll();
    }
}
