package com.ff.apimngr.service;

import com.ff.apimngr.dao.AppMapper;
import com.ff.apimngr.entity.App;
import com.ff.apimngr.entity.AppByDateVO;
import com.ff.apimngr.entity.OverviewVO;
import com.ff.apimngr.entity.TopApp;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class AppService {

    @Resource
    private AppMapper appMapper;

    public App findAppById(Integer id) {
        return appMapper.findById(id);
    }

    public App findAppByName(String name) {
        return appMapper.findByName(name);
    }


    public Integer insertApp(App app) {
        return appMapper.insert(app);
    }

    public boolean updateApp(App app) {
        return appMapper.update(app);
    }

    public boolean deleteAppById(Integer id) {
        return appMapper.deleteById(id);
    }

    public List<App> listApps(String tag, Integer status, Integer userId, Integer alarmStatus, String expireDate,Integer appTypeId) {
        return appMapper.listApps(tag, status, userId, alarmStatus, expireDate,appTypeId);
    }

    public List<App> listAppsByExpireDate(String expireDate) {
        return appMapper.listAppsByExpireDate(expireDate);
    }

    public Integer listAppsCount(Integer userId) {
        return appMapper.listAppsCount(userId);
    }
    public Integer appCount(List<Integer> appId,List<Integer> userId,Integer type) {
        return appMapper.appCount(appId,userId,type);
    }
    public List<AppByDateVO> appByDate(OverviewVO overviewVO) {
        return appMapper.appByDate(overviewVO);
    }

    public Integer listRecentAppCount(Integer userId) {
        return appMapper.listRecentAppCount(userId);
    }


    public int getAllAppNum() {
        return appMapper.getAllAppNum();
    }
    public int getTodayActiveAppNum(Long startTime) {
        return appMapper.getTodayActiveAppNum(startTime);
    }
    public int getMonthActiveAppNum(Long startTime) {
        return appMapper.getMonthActiveAppNum(startTime);
    }
    public int getAlarmAppNum() {
        return appMapper.getAlarmAppNum();
    }
    public int getAbnormalAppNum() {
        return appMapper.getAbnormalAppNum();
    }
    public int getIllegalAppNum() {
        return appMapper.getIllegalAppNum();
    }
//    public List<TopApp> getTopTenApps(String startDate, String endDate) {
//        return appMapper.getTopTenApps(startDate, endDate);
//    }

    public App findbyUserIdAndAppName(Integer userId, String appName) {
        return appMapper.findbyUserIdAndAppName(userId,appName);
    }

    public List<App> listAppsByApiId(Integer apiId){
    	return appMapper.listAppsByApiId(apiId);
    }
}
