package com.ff.apimngr.service;

import com.ff.apimngr.dao.AuthMapper;
import com.ff.apimngr.entity.Auth;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class AuthService {

    @Resource
    private AuthMapper authMapper;

    public Auth findAuthById(Integer id){
        return authMapper.findById(id);
    }


    public boolean insertAuth(Auth auth) {
        return authMapper.insert(auth);
    }

    public boolean updateAuth(Auth auth) {
        return authMapper.update(auth);
    }

    public boolean deleteAuthById(Integer id) {
        return authMapper.deleteById(id);
    }

    public boolean deleteAuthByRoleId(Integer roleId) {
        return authMapper.deleteByRoleId(roleId);
    }

    public List<Auth> listByRoleId(Integer roleId) {
        return authMapper.listByRoleId(roleId);
    }
}
