package com.ff.apimngr.service;

import com.ff.apimngr.dao.CodeInfoMapper;
import com.ff.apimngr.entity.CodeInfo;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;


@Service
public class CodeInfoService {

    @Resource
    private CodeInfoMapper codeInfoMapper;


    public CodeInfo findCodeInfoByCode(String errorCode) {
        return codeInfoMapper.findByCode(errorCode);
    }


    public boolean insertCodeInfo(CodeInfo codeInfo) {
        return codeInfoMapper.insert(codeInfo);
    }

    public boolean updateCodeInfo(CodeInfo codeInfo) {
        return codeInfoMapper.update(codeInfo);
    }

    public boolean deleteCodeInfoByCode(String errorCode) {
        return codeInfoMapper.deleteByCode(errorCode);
    }

    public List<CodeInfo> list(String tag) {
        return codeInfoMapper.list(tag);
    }
}
