/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package com.ff.apimngr.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.ff.apimngr.dao.DataApiMapper;
import com.ff.apimngr.entity.DataApi;
import com.ff.apimngr.entity.DataApiVO;
import org.springframework.stereotype.Service;

/**
 * 数据接口 服务实现类
 *
 * @author BladeX
 * @since 2021-04-17
 */
@Service
public class DataApiService extends ServiceImpl<DataApiMapper, DataApi> {

	public IPage<DataApiVO> selectDataApiPage(IPage<DataApiVO> page, DataApiVO dataApi) {
		return page.setRecords(baseMapper.selectDataApiPage(page, dataApi));
	}

	public DataApi getByApiKey(String apiKey){
		return baseMapper.getByApiKey(apiKey);
	}

}
