package com.ff.apimngr.service;

import com.ff.apimngr.dao.SmsLogMapper;
import com.ff.apimngr.entity.SmsLog;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class SmsLogService {

    @Resource
    private SmsLogMapper smsLogMapper;

    public SmsLog findSmsLogById(Integer id) {
        return smsLogMapper.findById(id);
    }

    public SmsLog findSmsLogByPhone(String phone) {
        return smsLogMapper.findByPhone(phone);
    }


    public boolean insertSmsLog(SmsLog smsLog) {
        return smsLogMapper.insert(smsLog);
    }

    public boolean updateSmsLog(SmsLog smsLog) {
        return smsLogMapper.update(smsLog);
    }

    public boolean deleteSmsLogById(Integer id) {
        return smsLogMapper.deleteById(id);
    }

    public List<SmsLog> listSmsLogs(String tag) {
        return smsLogMapper.listSmsLogs(tag);
    }

    public Integer listCount(String phone, String beginTime, String endTime) {
        return smsLogMapper.listCount(phone, beginTime, endTime);
    }
}
