/**
 * 
 */
package com.ff.apimngr.util;


import java.util.regex.Pattern;

/**
 * @author wookvn
 *
 */
public class CubeUtils {
	
	final static Pattern CHINESE_PATTERN = Pattern.compile("[\u4e00-\u9fa5]");
	//(?:--)|
	final static Pattern SQL_INJECT_PATTERN = Pattern.compile("(/\\*(?:.|[\\n\\r])*?\\*/)|(\\b(update|delete|drop|insert|alter|set|truncate|declare|exec|master|execute)\\b)", Pattern.CASE_INSENSITIVE);

	/**
	 * 是否包含中文字符串
	 * @param str
	 * @return
	 */
	public static boolean isContainsChinese(String str) {
		return CHINESE_PATTERN.matcher(str).find();
	}
	
	/**
	 * 校验是否Sql注入
	 * @param sql
	 * @return
	 */
	public static boolean checkSqlInject(String sql) {
		return SQL_INJECT_PATTERN.matcher(sql).find();
	}
	

	/**
	 * 是否手机号
	 * @param value
	 * @return
	 */
	static boolean _isMobile(String value) {
		return value.startsWith("1") && value.length() == 11;
	}
	
}