-- [xlc]
-- apimngr_new.data_api definition

CREATE TABLE `data_api` (
                            `id` int NOT NULL AUTO_INCREMENT COMMENT '主键自增',
                            `api_name` varchar(50) NOT NULL COMMENT '接口名称',
                            `api_key` varchar(50) NOT NULL COMMENT '唯一关键词',
                            `api_type` int DEFAULT '0' COMMENT '接口类别 0-报表 1-常规 2-第三方接口',
                            `category_id` int DEFAULT '0' COMMENT '接口分类id,关联 data_api_category表',
                            `api_formal` int DEFAULT '0' COMMENT '接口类型 1-正式 0-临时',
                            `api_url` varchar(300) DEFAULT NULL COMMENT '接口地址',
                            `datasource_id` int DEFAULT '0' COMMENT '数据源id',
                            `query_table` varchar(200) DEFAULT NULL COMMENT '查询表视图名称',
                            `query_param` text CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci COMMENT '查询条件',
                            `query_sql` text COMMENT '查询sql语句',
                            `api_status` int DEFAULT '0' COMMENT '接口状态 0-下线 1-上线 2-故障',
                            `login_required` int DEFAULT '0' COMMENT '是否需要登录 0-不需要 1-需要',
                            `pid` int DEFAULT NULL COMMENT '二级分类id',
                            `note` text COMMENT '扩展字段',
                            `remark` varchar(100) DEFAULT NULL COMMENT '备注',
                            `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                            `api_method` varchar(10) DEFAULT NULL COMMENT 'API接口请求方式(POST/GET)',
                            `api_headers` text COMMENT 'API接口请求头JSON',
                            `api_js_function` text COMMENT 'API接口返回数据解析js函数',
                            `api_param_type` tinyint DEFAULT '0' COMMENT 'API接口参数传递方式（0:json/1:x-www-form-urlencoded）',
                            `chart_type` tinyint DEFAULT NULL COMMENT '图表类型',
                            `create_user_id` bigint NOT NULL COMMENT '创建人ID',
                            `tenant_id` varchar(12) DEFAULT NULL COMMENT '租户id',
                            `is_page` tinyint NOT NULL DEFAULT '0' COMMENT '是否分页',
                            `page_size` tinyint DEFAULT NULL COMMENT '分页数量',
                            PRIMARY KEY (`id`),
                            UNIQUE KEY `api_key` (`api_key`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;



CREATE TABLE `data_api_category` (
                                     `id` int NOT NULL AUTO_INCREMENT COMMENT '主键 自增',
                                     `pid` int DEFAULT NULL COMMENT 'pid',
                                     `order_index` int NOT NULL DEFAULT '0' COMMENT '排序值，从小到大排',
                                     `category_name` varchar(50) NOT NULL COMMENT '指标分类名称',
                                     `remark` varchar(100) DEFAULT NULL COMMENT '备注',
                                     `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                     `create_user_id` bigint NOT NULL COMMENT '创建人ID',
                                     `tenant_id` varchar(12) DEFAULT NULL COMMENT '租户id',
                                     PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC;


CREATE TABLE `report_datasource` (
                                     `id` int NOT NULL AUTO_INCREMENT COMMENT '主键自增',
                                     `ds_ip` varchar(50) DEFAULT NULL COMMENT 'ip地址',
                                     `ds_port` int DEFAULT NULL COMMENT '端口',
                                     `ds_db` varchar(50) DEFAULT NULL COMMENT '数据库名/SID',
                                     `url` varchar(300) DEFAULT NULL COMMENT '连接url',
                                     `pool_name` varchar(50) NOT NULL COMMENT '连接名称',
                                     `driver_class_name` varchar(50) DEFAULT NULL COMMENT 'driverClassName',
                                     `ds_user` varchar(50) DEFAULT NULL COMMENT '用户名',
                                     `ds_password` varchar(50) DEFAULT NULL COMMENT '密码',
                                     `ds_type` int DEFAULT NULL COMMENT '数据源类型 0-mysql 1-oracle 2-sqlserver 3-postgresql 4-clickhouse',
                                     `is_deleted` int DEFAULT '0',
                                     `remark` varchar(200) DEFAULT NULL COMMENT '备注',
                                     `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                     `create_user_id` bigint DEFAULT NULL COMMENT '创建人ID',
                                     `responsible_person_id` bigint DEFAULT NULL COMMENT '责任人ID',
                                     `responsible_person_name` varchar(50) DEFAULT NULL COMMENT '责任人姓名',
                                     `db_schema` varchar(255) DEFAULT NULL COMMENT '模式',
                                     `tenant_id` varchar(12) DEFAULT NULL COMMENT '租户id',
                                     `is_edit` int DEFAULT '1' COMMENT '是否你能够编辑 0：不可以，1：可以',
                                     `custom_connect_properties` text,
                                     `jdbc_driver_jar_paths` text,
                                     `ds_name` varchar(100) DEFAULT NULL COMMENT '数据源名称',
                                     PRIMARY KEY (`id`),
                                     UNIQUE KEY `pool_name` (`pool_name`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC;


CREATE TABLE `report_table_category` (
                                         `id` int NOT NULL AUTO_INCREMENT COMMENT '主键 自增',
                                         `order_index` int DEFAULT '0' COMMENT '排序值，从小到大排',
                                         `datasource_id` int DEFAULT '0' COMMENT '数据源id',
                                         `category_name` varchar(50) NOT NULL COMMENT '指标分类名称',
                                         `remark` varchar(100) DEFAULT NULL COMMENT '备注',
                                         `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                         `tenant_id` varchar(12) DEFAULT NULL COMMENT '租户id',
                                         PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC;



CREATE TABLE `report_table_category_relation` (
                                                  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键 自增',
                                                  `order_index` int NOT NULL DEFAULT '0' COMMENT '排序值，从小到大排',
                                                  `category_id` int NOT NULL DEFAULT '0' COMMENT '分类id',
                                                  `table_view_name` varchar(50) NOT NULL COMMENT '视图表名称',
                                                  `table_comments` varchar(50) NOT NULL COMMENT '表中文名',
                                                  `tenant_id` varchar(12) DEFAULT NULL COMMENT '租户id',
                                                  `datasource_id` int DEFAULT NULL COMMENT '数据源ID',
                                                  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC;